Index: /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Experiment.Views/3.3/HiveJobView.cs
===================================================================
--- /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Experiment.Views/3.3/HiveJobView.cs	(revision 4423)
+++ /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Experiment.Views/3.3/HiveJobView.cs	(revision 4423)
@@ -0,0 +1,184 @@
+﻿using System;
+using System.Collections.Generic;
+using System.ComponentModel;
+using System.Drawing;
+using System.Data;
+using System.Linq;
+using System.Text;
+using System.Windows.Forms;
+using HeuristicLab.Core.Views;
+using HeuristicLab.MainForm;
+using HeuristicLab.Hive.JobBase;
+using HeuristicLab.Persistence.Default.Xml;
+using System.IO;
+using HeuristicLab.Hive.Experiment.Jobs;
+
+namespace HeuristicLab.Hive.Experiment.Views {
+  [View("HiveJob View")]
+  [Content(typeof(HiveJob), true)]
+  public partial class HiveJobView : ItemView {
+    public new HiveJob Content {
+      get { return (HiveJob)base.Content; }
+      set {
+        if (base.Content != value) {
+          base.Content = value;
+        }
+      }
+    }
+
+    public HiveJobView() {
+      InitializeComponent();
+    }
+
+    protected override void RegisterContentEvents() {
+      base.RegisterContentEvents();
+      Content.JobChanged += new EventHandler(Content_JobChanged);
+      Content.JobDtoChanged += new EventHandler(Content_JobDtoChanged);
+      Content.JobStateChanged += new EventHandler(Content_JobStateChanged);
+    }
+
+    protected override void DeregisterContentEvents() {
+      Content.JobChanged -= new EventHandler(Content_JobChanged);
+      Content.JobDtoChanged -= new EventHandler(Content_JobDtoChanged);
+      Content.JobStateChanged -= new EventHandler(Content_JobStateChanged);
+      base.DeregisterContentEvents();
+    }
+
+    protected override void OnContentChanged() {
+      base.OnContentChanged();
+      if (Content != null && Content.Job != null) {
+        logView.Content = Content.Job.Log;
+        childHiveJobView.Content = Content.ChildHiveJobs;
+        computeInParallelCheckBox.Checked = Content.Job.ComputeInParallel;
+      } else {
+        logView.Content = null;
+        childHiveJobView.Content = null;
+        computeInParallelCheckBox.Checked = false;
+      }
+      Content_JobChanged(this, EventArgs.Empty);
+      Content_JobDtoChanged(this, EventArgs.Empty);
+      Content_JobStateChanged(this, EventArgs.Empty);
+    }
+
+    void Content_JobChanged(object sender, EventArgs e) {
+      RegisterJobEvents();
+      Job_OptimizerChanged(this, e);
+    }
+
+    void Job_OptimizerChanged(object sender, EventArgs e) {
+      if (Content != null && Content.Job != null && Content.Job.Optimizer != null) {
+        optimizerNamedItemView.Content = Content.Job.Optimizer;
+        runCollectionView.Content = Content.Job.Optimizer.Runs;
+      } else {
+        optimizerNamedItemView.Content = null;
+        runCollectionView.Content = null;
+      }
+    }
+
+    private void RegisterJobEvents() {
+      if (Content != null && Content.Job != null) {
+        Content.Job.ComputeInParallelChanged += new EventHandler(Job_ComputeInParallelChanged);
+        Content.Job.OptimizerChanged += new EventHandler(Job_OptimizerChanged);
+      }
+    }
+
+    private void DeregisterJobEvents() {
+      if (Content != null && Content.Job != null) {
+        Content.Job.ComputeInParallelChanged -= new EventHandler(Job_ComputeInParallelChanged);
+        Content.Job.OptimizerChanged -= new EventHandler(Job_OptimizerChanged);
+      }
+    }
+
+    #region Content Events
+    private void Content_JobDtoChanged(object sender, EventArgs e) {
+      if (InvokeRequired) {
+        Invoke(new EventHandler(Content_JobDtoChanged), sender, e);
+      } else {
+        if (Content != null && Content.JobDto != null) {
+          this.jobIdTextBox.Text = Content.JobDto.Id.ToString();
+          this.dateCreatedTextBox.Text = Content.JobDto.DateCreated.ToString();
+          this.priorityTextBox.Text = Content.JobDto.Priority.ToString();
+          this.coresNeededTextBox.Text = Content.JobDto.CoresNeeded.ToString();
+          this.memoryNeededTextBox.Text = Content.JobDto.MemoryNeeded.ToString();
+        } else {
+          this.jobIdTextBox.Text = string.Empty;
+          this.dateCreatedTextBox.Text = string.Empty;
+          this.priorityTextBox.Text = string.Empty;
+          this.coresNeededTextBox.Text = string.Empty;
+          this.memoryNeededTextBox.Text = string.Empty;
+        }
+      }
+    }
+
+    private void Content_JobStateChanged(object sender, EventArgs e) {
+      if (InvokeRequired) {
+        Invoke(new EventHandler(Content_JobStateChanged), sender, e);
+      } else {
+        if (Content != null && Content.JobDto != null) {
+          this.stateTextBox.Text = Content.JobDto.State.ToString();
+          this.executionTimeTextBox.Text = Content.JobDto.ExecutionTime.ToString();
+          this.dateCalculatedText.Text = Content.JobDto.DateCalculated.ToString();
+          this.dateFinishedTextBox.Text = Content.JobDto.DateFinished.ToString();
+          this.exceptionTextBox.Text = Content.JobDto.Exception;
+        } else {
+          this.stateTextBox.Text = string.Empty;
+          this.executionTimeTextBox.Text = string.Empty;
+          this.dateCalculatedText.Text = string.Empty;
+          this.dateFinishedTextBox.Text = string.Empty;
+          this.exceptionTextBox.Text = string.Empty;
+        }
+      }
+    }
+
+    protected override void SetEnabledStateOfControls() {
+      if (InvokeRequired) {
+        this.InvokeIfRequired(c => { SetEnabledStateOfControls(); });
+      } else {
+        base.SetEnabledStateOfControls();
+        this.jobIdTextBox.ReadOnly = true;
+        this.stateTextBox.ReadOnly = true;
+        this.executionTimeTextBox.ReadOnly = true;
+        this.dateCreatedTextBox.ReadOnly = true;
+        this.dateCalculatedText.ReadOnly = true;
+        this.dateFinishedTextBox.ReadOnly = true;
+        this.exceptionTextBox.ReadOnly = true;
+
+        this.priorityTextBox.ReadOnly = this.ReadOnly;
+        this.coresNeededTextBox.ReadOnly = this.ReadOnly;
+        this.memoryNeededTextBox.ReadOnly = this.ReadOnly;
+        this.computeInParallelCheckBox.Enabled = !this.ReadOnly && this.Content != null && this.Content.Job != null && this.Content.Job.IsParallelizable;
+
+        optimizerNamedItemView.ReadOnly = true;
+        ShowOrHideChildJobTabPage();
+      }
+    }
+
+    void Job_ComputeInParallelChanged(object sender, EventArgs e) {
+      if (InvokeRequired) {
+        Invoke(new EventHandler(Job_ComputeInParallelChanged), sender, e);
+      } else {
+        computeInParallelCheckBox.Checked = Content.Job.ComputeInParallel;
+        ShowOrHideChildJobTabPage();
+      }
+    }
+
+    private void ShowOrHideChildJobTabPage() {
+      if (Content != null && Content.Job != null) {
+        if (!Content.Job.ComputeInParallel) {
+          if (tabControl.TabPages.Contains(childJobsTabPage))
+            tabControl.TabPages.Remove(childJobsTabPage);
+        } else {
+          if (!tabControl.TabPages.Contains(childJobsTabPage))
+            tabControl.TabPages.Insert(1, childJobsTabPage);
+        }
+      }
+    }
+    #endregion
+
+    private void computeInParallelCheckBox_CheckedChanged(object sender, EventArgs e) {
+      if (Content != null) {
+        this.Content.Job.ComputeInParallel = this.computeInParallelCheckBox.Checked;
+      }
+    }
+  }
+}
Index: /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Experiment.Views/3.3/ProgressView.cs
===================================================================
--- /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Experiment.Views/3.3/ProgressView.cs	(revision 4422)
+++ /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Experiment.Views/3.3/ProgressView.cs	(revision 4423)
@@ -12,6 +12,21 @@
 namespace HeuristicLab.Hive.Experiment.Views {
   public partial class ProgressView : HeuristicLab.MainForm.WindowsForms.View {
-    private ContentView parentView = null;
-    private bool simulateProgress = false;
+    private ContentView parentView;
+    private IProgress progress;
+    public IProgress Progress {
+      get {
+        return this.progress;
+      }
+      set {
+        if (this.progress != value) {
+          if (this.progress != null) {
+            DeregisterProgressEvents();
+          }
+          this.progress = value;
+          RegisterProgressEvents();
+          OnProgressChanged();
+        }
+      }
+    }
 
     public bool CancelEnabled {
@@ -28,47 +43,13 @@
     }
 
-    private string status;
-    public string Status {
-      get { return status; }
-      set {
-        if (InvokeRequired) {
-          Invoke(new Action<string>((s) => { Status = s;}), value);
-        } else {
-          status = value;
-          statusLabel.Text = status;
-        }
-        
-      }
-    }
-
-    public ProgressView(ContentView parentView)
-      : this(parentView, "", false, true) {
-    }
-
-    public ProgressView(ContentView parentView, string initialStatus)
-      : this(parentView, initialStatus, false, true) {
-    }
-
-    public ProgressView(ContentView parentView, string initialStatus, bool simulateProgress)
-      : this(parentView, initialStatus, simulateProgress, true) {
-    }
-
     /// <param name="parentView">This is the View which will be locked if lockParentView is true</param>
-    /// <param name="initialStatus">Status message</param>
-    /// <param name="simulateProgress">If true, the progress will be simulated by a timer which addes some progress every second</param>
-    /// <param name="lockParentView">if true parentView will be locked</param>
-    public ProgressView(ContentView parentView, string initialStatus, bool simulateProgress, bool lockParentView) {
+    public ProgressView(ContentView parentView, IProgress progress) {
       InitializeComponent();
       this.parentView = parentView;
+      this.Progress = progress;
+
       this.CancelEnabled = false;
-      this.Status = initialStatus;
-      this.simulateProgress = simulateProgress;
 
-      if (simulateProgress) {
-        Timer progressSimulator = new Timer();
-        progressSimulator.Interval = 2000;
-        progressSimulator.Tick += new EventHandler(progressSimulator_Tick);
-        progressSimulator.Start();
-      }
+      progressBar.Style = ProgressBarStyle.Marquee;
 
       this.Left = (parentView.ClientRectangle.Width / 2) - (this.Width / 2);
@@ -76,6 +57,5 @@
       this.Anchor = AnchorStyles.Left | AnchorStyles.Top;
 
-      if (lockParentView)
-        LockBackground();
+      LockBackground();
 
       parentView.Controls.Add(this);
@@ -83,22 +63,47 @@
     }
 
-    private void progressSimulator_Tick(object sender, EventArgs e) {
-      progressBar.Value = Math.Min(progressBar.Value + (progressBar.Maximum - progressBar.Value) / 10 + 1, progressBar.Maximum - 1);
+    private void RegisterProgressEvents() {
+      progress.Finished += new EventHandler(progress_Finished);
+      progress.StatusChanged += new EventHandler(progress_StatusChanged);
+      progress.ProgressValueChanged += new EventHandler(progress_ProgressChanged);
+    }
+
+    private void DeregisterProgressEvents() {
+      progress.Finished -= new EventHandler(progress_Finished);
+      progress.StatusChanged -= new EventHandler(progress_StatusChanged);
+      progress.ProgressValueChanged -= new EventHandler(progress_ProgressChanged);
+    }
+
+    void progress_Finished(object sender, EventArgs e) {
+      Finish();
+    }
+
+    void progress_ProgressChanged(object sender, EventArgs e) {
+      if (InvokeRequired) {
+        Invoke(new EventHandler(progress_ProgressChanged), sender, e);
+      } else {
+        progressBar.Style = ProgressBarStyle.Blocks;
+        this.progressBar.Value = Math.Min(this.progressBar.Maximum, (int)(progress.ProgressValue * progressBar.Maximum));
+      }
+    }
+
+    void progress_StatusChanged(object sender, EventArgs e) {
+      if (InvokeRequired) {
+        Invoke(new EventHandler(progress_StatusChanged), sender, e);
+      } else {
+        statusLabel.Text = progress.Status;
+      }
     }
 
     private void LockBackground() {
-      this.parentView.Locked = true;
-      foreach (Control c in this.parentView.Controls) {
-        c.Enabled = false;
-      }
-      this.Enabled = true;
-      this.ReadOnly = false;
-    }
-
-    public void SetProgress(double progress) {
       if (InvokeRequired) {
-        Invoke(new Action<double>(SetProgress), progress);
+        Invoke(new Action(LockBackground));
       } else {
-        this.progressBar.Value = Math.Max(this.progressBar.Value, (int)(progress * progressBar.Maximum));
+        this.parentView.Locked = true;
+        foreach (Control c in this.parentView.Controls) {
+          c.Enabled = false;
+        }
+        this.Enabled = true;
+        this.ReadOnly = false;
       }
     }
@@ -122,4 +127,9 @@
     }
 
+    private void OnProgressChanged() {
+      progress_StatusChanged(this, EventArgs.Empty);
+      progress_ProgressChanged(this, EventArgs.Empty);
+    }
+
     public event EventHandler Canceled;
     protected virtual void OnCanceled() {
Index: /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Experiment/3.3/Exceptions/AddJobToHiveException.cs
===================================================================
--- /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Experiment/3.3/Exceptions/AddJobToHiveException.cs	(revision 4423)
+++ /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Experiment/3.3/Exceptions/AddJobToHiveException.cs	(revision 4423)
@@ -0,0 +1,10 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+
+namespace HeuristicLab.Hive.Experiment {
+  class AddJobToHiveException : Exception {
+    public AddJobToHiveException(string message) : base(message) { }
+  }
+}
Index: /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Experiment/3.3/Exceptions/JobResultPollingException.cs
===================================================================
--- /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Experiment/3.3/Exceptions/JobResultPollingException.cs	(revision 4423)
+++ /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Experiment/3.3/Exceptions/JobResultPollingException.cs	(revision 4423)
@@ -0,0 +1,10 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+
+namespace HeuristicLab.Hive.Experiment {
+  class JobResultPollingException : Exception {
+    public JobResultPollingException(string message) : base(message) { }
+  }
+}
Index: /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Experiment/3.3/Exceptions/OptimizerNotFoundException.cs
===================================================================
--- /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Experiment/3.3/Exceptions/OptimizerNotFoundException.cs	(revision 4423)
+++ /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Experiment/3.3/Exceptions/OptimizerNotFoundException.cs	(revision 4423)
@@ -0,0 +1,12 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+
+namespace HeuristicLab.Hive.Experiment {
+  class OptimizerNotFoundException : Exception {
+
+    public OptimizerNotFoundException(string message) : base(message) {
+    }
+  }
+}
Index: /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Experiment/3.3/HeuristicLab.Hive.Experiment-3.3.csproj
===================================================================
--- /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Experiment/3.3/HeuristicLab.Hive.Experiment-3.3.csproj	(revision 4422)
+++ /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Experiment/3.3/HeuristicLab.Hive.Experiment-3.3.csproj	(revision 4423)
@@ -118,14 +118,19 @@
   </ItemGroup>
   <ItemGroup>
-    <Compile Include="JobItem.cs" />
-    <Compile Include="JobItemList.cs" />
-    <Compile Include="Jobs\BachRunJob.cs" />
+    <Compile Include="Exceptions\AddJobToHiveException.cs" />
+    <Compile Include="HiveExperiment.cs" />
+    <Compile Include="HiveJob.cs" />
+    <Compile Include="HiveJobList.cs" />
+    <Compile Include="Progress\IProgress.cs" />
+    <Compile Include="Progress\IProgressReporter.cs" />
+    <Compile Include="JobResultPoller.cs" />
+    <Compile Include="Exceptions\JobResultPollingException.cs" />
     <Compile Include="Jobs\JobList.cs" />
-    <Compile Include="Jobs\ExperimentJob.cs" />
     <Compile Include="HiveClient.cs" />
     <Compile Include="HiveExperimentList.cs" />
     <Compile Include="Jobs\OptimizerJob.cs" />
     <Compile Include="HeuristicLabHiveExperimentPlugin.cs" />
-    <Compile Include="HiveExperiment.cs" />
+    <Compile Include="Exceptions\OptimizerNotFoundException.cs" />
+    <Compile Include="Progress\Progress.cs" />
     <Compile Include="Properties\AssemblyInfo.cs" />
     <Compile Include="Properties\Settings.Designer.cs">
Index: /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Experiment/3.3/HiveClient.cs
===================================================================
--- /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Experiment/3.3/HiveClient.cs	(revision 4422)
+++ /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Experiment/3.3/HiveClient.cs	(revision 4423)
@@ -11,10 +11,14 @@
 using System.ServiceModel;
 using HeuristicLab.Hive.Contracts;
+using HeuristicLab.DataAccess;
+using HeuristicLab.Collections;
+using HeuristicLab.Common;
 
 namespace HeuristicLab.Hive.Experiment {
   [Item("Hive Client", "Connects to Hive and lists all submitted experiments by the current user.")]
   [Creatable("Hive")]
-  public class HiveClient : Item {
+  public class HiveClient : Item, IProgressReporter {
     private static object locker = new object();
+    private bool currentlyUpdating;
 
     private ILog log;
@@ -28,7 +32,5 @@
       set {
         if (hiveExperiments != value) {
-          if (hiveExperiments != null) {
-            DeRegisterHiveExperimentsEvents();
-          }
+          DeRegisterHiveExperimentsEvents();
           hiveExperiments = value;
           RegisterHiveExperimentsEvent();
@@ -38,22 +40,35 @@
     }
 
+    private bool isProgressing;
+    public bool IsProgressing {
+      get { return isProgressing; }
+      set {
+        if (isProgressing != value) {
+          isProgressing = value;
+          OnIsProgressingChanged();
+        }
+      }
+    }
+
+    private IProgress progress;
+    public IProgress Progress {
+      get { return progress; }
+    }
+
     private void RegisterHiveExperimentsEvent() {
-      hiveExperiments.ItemsAdded += new Collections.CollectionItemsChangedEventHandler<Collections.IndexedItem<HiveExperiment>>(hiveExperiments_ItemsAdded);
-      hiveExperiments.ItemsRemoved += new Collections.CollectionItemsChangedEventHandler<Collections.IndexedItem<HiveExperiment>>(hiveExperiments_ItemsRemoved);
-      hiveExperiments.ItemsMoved += new Collections.CollectionItemsChangedEventHandler<Collections.IndexedItem<HiveExperiment>>(hiveExperiments_ItemsMoved);
+      if (hiveExperiments != null) {
+        hiveExperiments.ItemsRemoved += new CollectionItemsChangedEventHandler<IndexedItem<HiveExperiment>>(hiveExperiments_ItemsRemoved);
+      }
     }
 
     private void DeRegisterHiveExperimentsEvents() {
-      hiveExperiments.ItemsAdded -= new Collections.CollectionItemsChangedEventHandler<Collections.IndexedItem<HiveExperiment>>(hiveExperiments_ItemsAdded);
-      hiveExperiments.ItemsRemoved -= new Collections.CollectionItemsChangedEventHandler<Collections.IndexedItem<HiveExperiment>>(hiveExperiments_ItemsRemoved);
-      hiveExperiments.ItemsMoved -= new Collections.CollectionItemsChangedEventHandler<Collections.IndexedItem<HiveExperiment>>(hiveExperiments_ItemsMoved);
-
+      if (hiveExperiments != null) {
+        hiveExperiments.ItemsRemoved -= new CollectionItemsChangedEventHandler<IndexedItem<HiveExperiment>>(hiveExperiments_ItemsRemoved);
+      }
     }
 
     public HiveClient() {
       this.log = new Log();
-      this.HiveExperiments = new HiveExperimentList();
     }
-
 
     public override Common.IDeepCloneable Clone(Common.Cloner cloner) {
@@ -65,46 +80,43 @@
 
     public void UpdateExperimentList() {
-      //IClientFacade client = CreateClientFacade();
-      using (Disposable<IClientFacade> service = ServiceLocator.Instance.ClientFacadePool.GetService()) {
-        ResponseObject<JobResultList> response = service.Obj.GetChildJobResults(null, false, false);
-        RefreshExperimentList(response.Obj);
+      this.progress = new Progress("Downloading HiveExperiments...");
+      try {
+        IsProgressing = true;
+        if (this.HiveExperiments == null) {
+          this.HiveExperiments = new HiveExperimentList();
+        }
+        using (Disposable<IClientFacade> service = ServiceLocator.Instance.ClientFacadePool.GetService()) {
+          currentlyUpdating = true;
+          ResponseObject<HiveExperimentDtoList> response = service.Obj.GetHiveExperiments();
+          progress.Status = "Populating HiveExperiment list...";
+          RefreshExperimentList(response.Obj);
+          currentlyUpdating = false;
+        }
       }
-      //ServiceLocator.DisposeClientFacade(client);
+      catch (Exception) {
+        this.HiveExperiments = null;
+        throw;
+      }
+      finally {
+        IsProgressing = false;
+      }
     }
 
-    private void RefreshExperimentList(JobResultList jobResultList) {
-      foreach (JobResult jobResult in jobResultList) {
-        HiveExperiment hiveExperiment = GetHiveExperiment(jobResult);
+    private void RefreshExperimentList(HiveExperimentDtoList hiveExperiments) {
+      foreach (HiveExperimentDto hiveExperimentDto in hiveExperiments) {
+        HiveExperiment hiveExperiment = GetHiveExperiment(hiveExperimentDto.Id);
         if (hiveExperiment == null) {
-          // create new
-          hiveExperiment = new HiveExperiment() { RootJobItem = new JobItem(jobResult) };
-          this.hiveExperiments.Add(hiveExperiment);
+          // not yet there, create new
+          this.HiveExperiments.Add(new HiveExperiment(hiveExperimentDto));
         } else {
           // update
-          //hiveExperiment.RootJob.UpdateJob(jobResult);
+          hiveExperiment.UpdateFromDto(hiveExperimentDto);
         }
       }
     }
 
-    private HiveExperiment GetHiveExperiment(JobResult jobResult) {
-      //var matches = this.hiveExperiments.Where(exp => exp.RootJob != null && exp.RootJob.JobDto.Id == jobResult.JobId);
-      //if (matches.Count() == 0) {
-      //  return null;
-      //} else {
-      //  return matches.First();
-      //}
-      return null;
+    private HiveExperiment GetHiveExperiment(Guid hiveExperimentId) {
+      return this.HiveExperiments.SingleOrDefault(he => he.HiveExperimentId.Equals(hiveExperimentId));
     }
-
-    //private IClientFacade CreateClientFacade() {
-    //  IClientFacade clientFacade = null;
-    //  try {
-    //    clientFacade = ServiceLocator.CreateClientFacade(Settings.Default.HiveServerIp);
-    //  }
-    //  catch (EndpointNotFoundException exception) {
-    //    LogMessage("Could not connect to Server: " + exception.Message);
-    //  }
-    //  return clientFacade;
-    //}
 
     private void LogMessage(string message) {
@@ -120,17 +132,22 @@
       if (handler != null) handler(this, EventArgs.Empty);
     }
-
-    void hiveExperiments_ItemsAdded(object sender, Collections.CollectionItemsChangedEventArgs<Collections.IndexedItem<HiveExperiment>> e) {
-      
+    
+    void hiveExperiments_ItemsRemoved(object sender, Collections.CollectionItemsChangedEventArgs<Collections.IndexedItem<HiveExperiment>> e) {
+      if (!currentlyUpdating) {
+        using (Disposable<IClientFacade> service = ServiceLocator.Instance.ClientFacadePool.GetService()) {
+          foreach (IndexedItem<HiveExperiment> item in e.Items) {
+            if (item.Value.HiveExperimentId != Guid.Empty) {
+              service.Obj.DeleteHiveExperiment(item.Value.HiveExperimentId);
+            }
+          }
+        }
+      }
     }
 
-    void hiveExperiments_ItemsRemoved(object sender, Collections.CollectionItemsChangedEventArgs<Collections.IndexedItem<HiveExperiment>> e) {
-      
+    public event EventHandler IsProgressingChanged;
+    private void OnIsProgressingChanged() {
+      var handler = IsProgressingChanged;
+      if (handler != null) handler(this, EventArgs.Empty);
     }
-
-    void hiveExperiments_ItemsMoved(object sender, Collections.CollectionItemsChangedEventArgs<Collections.IndexedItem<HiveExperiment>> e) {
-      
-    }
-
   }
 }
